#line 1 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
/*
* Copyright (c) 2017, Intel Corporation
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  * Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*  * Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*  * Neither the name of Intel Corporation nor the names of its contributors
*    may be used to endorse or promote products derived from this software
*    without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*/

/**
* \file
* \brief Parser for control verbs that can occur at the beginning of a pattern.
*/

#include "parser/control_verbs.h"

#include "parser/Parser.h"
#include "parser/parse_error.h"

#include <cstring>
#include <sstream>

using namespace std;

namespace ue2 {
	
	const char *read_control_verbs(const char *ptr, const char *end, size_t start,
	ParseMode &mode) {
		const char *p = ptr;
		const char *pe = end;
		const char *eof = pe;
		const char *ts, *te;
		int cs;
		UNUSED int act;
		
		
#line 58 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
		static const signed char _ControlVerbs_actions[] = {
			0, 1, 0, 1, 1, 1, 2, 1,
			3, 1, 4, 1, 5, 1, 6, 1,
			7, 1, 8, 1, 9, 0
		};
		
		static const signed char _ControlVerbs_to_state_actions[] = {
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 1, 0, 0
		};
		
		static const int ControlVerbs_start = 75;
		static const int ControlVerbs_first_final = 75;
		static const int ControlVerbs_error = -1;
		
		static const int ControlVerbs_en_main = 75;
		
		
#line 85 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
		{
			cs = (int)ControlVerbs_start;
			ts = 0;
			te = 0;
		}
		
#line 106 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
		
		
		try {
			
#line 97 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
			{
				const signed char * _acts;
				unsigned int _nacts;
				
				_resume: {}
				if ( p == pe && p != eof )
					goto _out;
				switch ( cs ) {
					case 75:
					{
#line 1 "NONE"
						{ts = p;}}
					
#line 111 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
					
					if ( p == eof ) {
						goto _ctr79;	goto _again;
					}
					else {
						if ( ( (*( p))) == 40u ) {
							goto _ctr81;
						}
						goto _ctr80;
					}
					case 76:
					if ( p == eof ) {
						goto _ctr82;	goto _again;
					}
					else {
						if ( ( (*( p))) == 42u ) {
							goto _ctr83;
						}
						goto _ctr82;
					}
					case 0:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr0;
							}
							case 65u: {
								goto _ctr2;
							}
							case 66u: {
								goto _ctr3;
							}
							case 67u: {
								goto _ctr4;
							}
							case 76u: {
								goto _ctr5;
							}
							case 78u: {
								goto _ctr6;
							}
							case 85u: {
								goto _ctr7;
							}
						}
						goto _ctr1;
					}
					case 1:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr8;
						}
						goto _ctr1;
					}
					case 2:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 78u: {
								goto _ctr9;
							}
						}
						goto _ctr1;
					}
					case 3:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 89u: {
								goto _ctr10;
							}
						}
						goto _ctr1;
					}
					case 4:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr11;
							}
							case 67u: {
								goto _ctr12;
							}
						}
						goto _ctr1;
					}
					case 5:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 82u: {
								goto _ctr13;
							}
						}
						goto _ctr1;
					}
					case 6:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 76u: {
								goto _ctr14;
							}
						}
						goto _ctr1;
					}
					case 7:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 70u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 8:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr11;
						}
						goto _ctr1;
					}
					case 9:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr16;
							}
						}
						goto _ctr1;
					}
					case 10:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 82u: {
								goto _ctr17;
							}
						}
						goto _ctr1;
					}
					case 11:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 95u: {
								goto _ctr18;
							}
						}
						goto _ctr1;
					}
					case 12:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 65u: {
								goto _ctr19;
							}
							case 85u: {
								goto _ctr20;
							}
						}
						goto _ctr1;
					}
					case 13:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 78u: {
								goto _ctr21;
							}
						}
						goto _ctr1;
					}
					case 14:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 89u: {
								goto _ctr22;
							}
						}
						goto _ctr1;
					}
					case 15:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 67u: {
								goto _ctr12;
							}
						}
						goto _ctr1;
					}
					case 16:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 78u: {
								goto _ctr23;
							}
						}
						goto _ctr1;
					}
					case 17:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 73u: {
								goto _ctr24;
							}
						}
						goto _ctr1;
					}
					case 18:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 67u: {
								goto _ctr25;
							}
						}
						goto _ctr1;
					}
					case 19:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr26;
							}
						}
						goto _ctr1;
					}
					case 20:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 68u: {
								goto _ctr27;
							}
						}
						goto _ctr1;
					}
					case 21:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 69u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 22:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 82u: {
								goto _ctr28;
							}
						}
						goto _ctr1;
					}
					case 23:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr11;
							}
							case 76u: {
								goto _ctr14;
							}
						}
						goto _ctr1;
					}
					case 24:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 70u: {
								goto _ctr15;
							}
							case 73u: {
								goto _ctr29;
							}
						}
						goto _ctr1;
					}
					case 25:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 77u: {
								goto _ctr30;
							}
						}
						goto _ctr1;
					}
					case 26:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 73u: {
								goto _ctr31;
							}
						}
						goto _ctr1;
					}
					case 27:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr32;
							}
						}
						goto _ctr1;
					}
					case 28:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 95u: {
								goto _ctr33;
							}
						}
						goto _ctr1;
					}
					case 29:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 77u: {
								goto _ctr34;
							}
							case 82u: {
								goto _ctr35;
							}
						}
						goto _ctr1;
					}
					case 30:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 65u: {
								goto _ctr36;
							}
						}
						goto _ctr1;
					}
					case 31:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr37;
							}
						}
						goto _ctr1;
					}
					case 32:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 67u: {
								goto _ctr38;
							}
						}
						goto _ctr1;
					}
					case 33:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 72u: {
								goto _ctr39;
							}
						}
						goto _ctr1;
					}
					case 34:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 61u: {
								goto _ctr40;
							}
						}
						goto _ctr1;
					}
					case 35:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr8;
						}
						if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
							goto _ctr41;
						}
						goto _ctr1;
					}
					case 36:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr11;
						}
						if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
							goto _ctr41;
						}
						goto _ctr1;
					}
					case 37:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 69u: {
								goto _ctr42;
							}
						}
						goto _ctr1;
					}
					case 38:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 67u: {
								goto _ctr43;
							}
						}
						goto _ctr1;
					}
					case 39:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 85u: {
								goto _ctr44;
							}
						}
						goto _ctr1;
					}
					case 40:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 82u: {
								goto _ctr45;
							}
						}
						goto _ctr1;
					}
					case 41:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr46;
							}
						}
						goto _ctr1;
					}
					case 42:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 73u: {
								goto _ctr47;
							}
						}
						goto _ctr1;
					}
					case 43:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr48;
							}
						}
						goto _ctr1;
					}
					case 44:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 78u: {
								goto _ctr39;
							}
						}
						goto _ctr1;
					}
					case 45:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr49;
							}
						}
						goto _ctr1;
					}
					case 46:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 95u: {
								goto _ctr50;
							}
						}
						goto _ctr1;
					}
					case 47:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 65u: {
								goto _ctr51;
							}
							case 83u: {
								goto _ctr52;
							}
						}
						goto _ctr1;
					}
					case 48:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 85u: {
								goto _ctr53;
							}
						}
						goto _ctr1;
					}
					case 49:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr54;
							}
						}
						goto _ctr1;
					}
					case 50:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr55;
							}
						}
						goto _ctr1;
					}
					case 51:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 95u: {
								goto _ctr56;
							}
						}
						goto _ctr1;
					}
					case 52:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 80u: {
								goto _ctr57;
							}
						}
						goto _ctr1;
					}
					case 53:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr58;
							}
						}
						goto _ctr1;
					}
					case 54:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr59;
							}
						}
						goto _ctr1;
					}
					case 55:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr60;
							}
						}
						goto _ctr1;
					}
					case 56:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 69u: {
								goto _ctr61;
							}
						}
						goto _ctr1;
					}
					case 57:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr62;
							}
						}
						goto _ctr1;
					}
					case 58:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 83u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 59:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr63;
							}
						}
						goto _ctr1;
					}
					case 60:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 65u: {
								goto _ctr64;
							}
						}
						goto _ctr1;
					}
					case 61:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 82u: {
								goto _ctr65;
							}
						}
						goto _ctr1;
					}
					case 62:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr66;
							}
						}
						goto _ctr1;
					}
					case 63:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 95u: {
								goto _ctr67;
							}
						}
						goto _ctr1;
					}
					case 64:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 79u: {
								goto _ctr68;
							}
						}
						goto _ctr1;
					}
					case 65:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 80u: {
								goto _ctr69;
							}
						}
						goto _ctr1;
					}
					case 66:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 84u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 67:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 67u: {
								goto _ctr70;
							}
							case 84u: {
								goto _ctr71;
							}
						}
						goto _ctr1;
					}
					case 68:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 80u: {
								goto _ctr72;
							}
						}
						goto _ctr1;
					}
					case 69:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr73;
						}
						goto _ctr1;
					}
					case 70:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 70u: {
								goto _ctr74;
							}
						}
						goto _ctr1;
					}
					case 71:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr75;
							}
							case 49u: {
								goto _ctr76;
							}
							case 51u: {
								goto _ctr77;
							}
							case 56u: {
								goto _ctr78;
							}
						}
						goto _ctr1;
					}
					case 72:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 54u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 73:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						switch( ( (*( p))) ) {
							case 41u: {
								goto _ctr8;
							}
							case 50u: {
								goto _ctr15;
							}
						}
						goto _ctr1;
					}
					case 74:
					if ( p == eof ) {
						goto _ctr0;	goto _again;
					}
					else {
						if ( ( (*( p))) == 41u ) {
							goto _ctr75;
						}
						goto _ctr1;
					}
				}
				
				_ctr83: cs = 0; goto _again;
				_ctr1: cs = 1; goto _again;
				_ctr2: cs = 2; goto _again;
				_ctr9: cs = 3; goto _again;
				_ctr10: cs = 4; goto _again;
				_ctr12: cs = 5; goto _again;
				_ctr13: cs = 6; goto _again;
				_ctr14: cs = 7; goto _again;
				_ctr15: cs = 8; goto _again;
				_ctr3: cs = 9; goto _again;
				_ctr16: cs = 10; goto _again;
				_ctr17: cs = 11; goto _again;
				_ctr18: cs = 12; goto _again;
				_ctr19: cs = 13; goto _again;
				_ctr21: cs = 14; goto _again;
				_ctr22: cs = 15; goto _again;
				_ctr20: cs = 16; goto _again;
				_ctr23: cs = 17; goto _again;
				_ctr24: cs = 18; goto _again;
				_ctr25: cs = 19; goto _again;
				_ctr26: cs = 20; goto _again;
				_ctr27: cs = 21; goto _again;
				_ctr4: cs = 22; goto _again;
				_ctr28: cs = 23; goto _again;
				_ctr5: cs = 24; goto _again;
				_ctr29: cs = 25; goto _again;
				_ctr30: cs = 26; goto _again;
				_ctr31: cs = 27; goto _again;
				_ctr32: cs = 28; goto _again;
				_ctr33: cs = 29; goto _again;
				_ctr34: cs = 30; goto _again;
				_ctr36: cs = 31; goto _again;
				_ctr37: cs = 32; goto _again;
				_ctr38: cs = 33; goto _again;
				_ctr39: cs = 34; goto _again;
				_ctr40: cs = 35; goto _again;
				_ctr41: cs = 36; goto _again;
				_ctr35: cs = 37; goto _again;
				_ctr42: cs = 38; goto _again;
				_ctr43: cs = 39; goto _again;
				_ctr44: cs = 40; goto _again;
				_ctr45: cs = 41; goto _again;
				_ctr46: cs = 42; goto _again;
				_ctr47: cs = 43; goto _again;
				_ctr48: cs = 44; goto _again;
				_ctr6: cs = 45; goto _again;
				_ctr49: cs = 46; goto _again;
				_ctr50: cs = 47; goto _again;
				_ctr51: cs = 48; goto _again;
				_ctr53: cs = 49; goto _again;
				_ctr54: cs = 50; goto _again;
				_ctr55: cs = 51; goto _again;
				_ctr56: cs = 52; goto _again;
				_ctr57: cs = 53; goto _again;
				_ctr58: cs = 54; goto _again;
				_ctr59: cs = 55; goto _again;
				_ctr60: cs = 56; goto _again;
				_ctr61: cs = 57; goto _again;
				_ctr62: cs = 58; goto _again;
				_ctr52: cs = 59; goto _again;
				_ctr63: cs = 60; goto _again;
				_ctr64: cs = 61; goto _again;
				_ctr65: cs = 62; goto _again;
				_ctr66: cs = 63; goto _again;
				_ctr67: cs = 64; goto _again;
				_ctr68: cs = 65; goto _again;
				_ctr69: cs = 66; goto _again;
				_ctr7: cs = 67; goto _again;
				_ctr70: cs = 68; goto _again;
				_ctr72: cs = 69; goto _again;
				_ctr71: cs = 70; goto _again;
				_ctr74: cs = 71; goto _again;
				_ctr76: cs = 72; goto _again;
				_ctr77: cs = 73; goto _again;
				_ctr78: cs = 74; goto _again;
				_ctr79: cs = 75; goto _again;
				_ctr0: cs = 75; goto f0;
				_ctr8: cs = 75; goto f1;
				_ctr11: cs = 75; goto f2;
				_ctr73: cs = 75; goto f3;
				_ctr75: cs = 75; goto f4;
				_ctr80: cs = 75; goto f7;
				_ctr82: cs = 75; goto f9;
				_ctr81: cs = 76; goto f8;
				
				f8: _acts = ( _ControlVerbs_actions + (5)); goto execFuncs;
				f4: _acts = ( _ControlVerbs_actions + (7)); goto execFuncs;
				f3: _acts = ( _ControlVerbs_actions + (9)); goto execFuncs;
				f2: _acts = ( _ControlVerbs_actions + (11)); goto execFuncs;
				f1: _acts = ( _ControlVerbs_actions + (13)); goto execFuncs;
				f7: _acts = ( _ControlVerbs_actions + (15)); goto execFuncs;
				f9: _acts = ( _ControlVerbs_actions + (17)); goto execFuncs;
				f0: _acts = ( _ControlVerbs_actions + (19)); goto execFuncs;
				
				execFuncs:
				_nacts = (unsigned int)(*( _acts));
				_acts += 1;
				while ( _nacts > 0 ) {
					switch ( (*( _acts)) ) {
						case 2: {
							{
#line 1 "NONE"
								{te = p+1;}}
							
#line 1375 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 3: {
							{
#line 77 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p+1;{
#line 77 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										mode.utf8 = true;
									}
								}}
							
#line 1389 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 4: {
							{
#line 81 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p+1;{
#line 81 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										mode.ucp = true;
									}
								}}
							
#line 1403 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 5: {
							{
#line 85 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p+1;{
#line 85 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										ostringstream str;
										str << "Unsupported control verb " << string(ts, te - ts);
										throw LocatedParseError(str.str());
									}
								}}
							
#line 1419 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 6: {
							{
#line 91 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p+1;{
#line 91 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										ostringstream str;
										str << "Unknown control verb " << string(ts, te - ts);
										throw LocatedParseError(str.str());
									}
								}}
							
#line 1435 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 7: {
							{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p+1;{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										{p = p - 1; }
										{p += 1; goto _out; }
									}
								}}
							
#line 1450 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 8: {
							{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{te = p;p = p - 1;{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										{p = p - 1; }
										{p += 1; goto _out; }
									}
								}}
							
#line 1465 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
						case 9: {
							{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
								{p = ((te))-1;
									{
#line 98 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
										
										{p = p - 1; }
										{p += 1; goto _out; }
									}
								}}
							
#line 1481 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
							
							break; 
						}
					}
					_acts += 1;
					_nacts -= 1;
				}
				
				goto _again;
				
				_again: {}
				if ( p == eof ) {
					if ( cs >= 75 )
						goto _out;
				}
				else {
					_acts = ( _ControlVerbs_actions + (_ControlVerbs_to_state_actions[cs]));
					_nacts = (unsigned int)(*( _acts)); _acts += 1;
					while ( _nacts > 0 ) {
						switch ( (*( _acts)) ) {
							case 0: {
								{
#line 1 "NONE"
									{ts = 0;}}
								
#line 1507 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.cpp"
								
								break; 
							}
						}
						_acts += 1;
						_nacts -= 1;
					}
					
					p += 1;
					goto _resume;
				}
				_out: {}
			}
			
#line 109 "/builddir/build/BUILD/vectorscan-d29730e1cb9daaa66bda63426cdce83505d2c809/src/parser/control_verbs.rl"
			
		} catch (LocatedParseError &error) {
			if (ts >= ptr && ts <= pe) {
				error.locate(ts - ptr + start);
			} else {
				error.locate(0);
			}
			throw;
		}
		
		return p;
	}
	
} // namespace ue2
